// u_c_person
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_30_rtti_databinding;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    create_person_: TButton;
    bind_controls_: TButton;
    set_random_age_: TButton;
    name_edit_: TEdit;
    age_trackbar_: TTrackBar;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure create_person_Click(Sender: TObject);
    procedure bind_controls_Click(Sender: TObject);
    procedure set_random_age_Click(Sender: TObject);
    procedure d_Click(Sender: TObject);
    procedure e_Click(Sender: TObject);
    procedure f_Click(Sender: TObject);
    procedure g_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses u_display_simple
        , u_c_person_properties_5
        , u_c_rtti_databinder_5
        ;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end; // FormCreate


    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    var g_c_person: c_person= Nil;

    procedure TForm1.create_person_Click(Sender: TObject);
      begin
        g_c_person:= c_person.create_person('joe', 41);
      end; // create_person_Click

    procedure TForm1.bind_controls_Click(Sender: TObject);
      begin
        with g_c_person do
        begin
          add_target_object(g_c_person, 'Name', name_edit_, 'Text');
          add_target_object(g_c_person, 'Age', age_trackbar_, 'Position');

          update_target_values;
        end;
      end; // bind_controls_Click

    procedure TForm1.set_random_age_Click(Sender: TObject);
      var l_age: Integer;
      begin
        l_age:= 20+ Random(75);
        display('');
        display('set_random_age '+ IntToStr(l_age));
        g_c_person.Age:= l_age;
      end; // set_random_age_Click

    procedure TForm1.d_Click(Sender: TObject);
      begin

      end; // d_

    procedure TForm1.e_Click(Sender: TObject);
      begin

      end; // e_

    procedure TForm1.f_Click(Sender: TObject);
      begin

      end; // f_

    procedure TForm1.g_Click(Sender: TObject);
      begin

      end; // g_

end.
